import { Document } from "@gltf-transform/core";
import { Primitive } from "@gltf-transform/core";
import { FeatureId } from "../gltfExtensions/MeshFeatures";
/**
 * Methods related to the conversion of legacy tile table data
 * to the `EXT_mesh_features` extension.
 *
 * @internal
 */
export declare class TileTableDataToMeshFeatures {
    /**
     * Convert the `_BATCHID` attribute in the given primitive into
     * an instance of the `ETX_mesh_features` extension that is
     * associated with this primitive, storing the former `_BATCHID`
     * attribute as a new `_FEATURE_ID_0` attribute.
     *
     * @param document - The glTF-Transform document
     * @param primitive - The glTF-Transform primitive
     * @returns The glTF-Transform `FeatureId` object that has
     * been created
     * @throws TileFormatError If the given primitive does not
     * contain a valid `_BATCHID` attribute.
     */
    static convertBatchIdToMeshFeatures(document: Document, primitive: Primitive): FeatureId;
}
//# sourceMappingURL=TileTableDataToMeshFeatures.d.ts.map